import 'package:models_weebi/src/closings/abstract/closing_shop.dart';
import 'package:models_weebi/src/closings/closing_stock_article.dart';
import 'package:models_weebi/utils.dart';

class ClosingStockShopArticle extends ClosingStockArticle
    implements ClosingShopAbstract {
  @override
  String shopUuid;

  ClosingStockShopArticle(
    super.closingDate, {
    this.shopUuid = '',
    required super.productId,
    required super.id,
    required super.fullName,
    required super.weight,
    required super.quantityIn,
    required super.quantityOut,
    required super.initialQtCl,
    required double finalQtCl,
  }) : super(
          finalQtCl: initialQtCl,
        );

  @override
  Map<String, dynamic> toMap() {
    return {
      'closingDate': closingDate.toIso8601String(),
      'shopUuid': shopUuid,
      'productId': productId,
      'id': id,
      'fullName': fullName,
      'weight': weight,
      'quantityIn': quantityIn,
      'quantityOut': quantityOut,
      'initialQtCl': initialQtCl,
      'finalQtCl': finalQtCl,
    };
  }

  factory ClosingStockShopArticle.fromMap(Map<String, dynamic> map) {
    return ClosingStockShopArticle(
      DateTime.tryParse(map['closingDate']) ?? WeebiDates.defaultDate,
      shopUuid: map['shopUuid'] as String,
      productId: map['productId'] as int,
      id: map['id'] as int,
      fullName: map['fullName'] as String,
      weight: map['weight'] == null ? 1.0 : (map['weight'] as num).toDouble(),
      quantityIn: map['quantityIn'] == null
          ? 0.0
          : (map['quantityIn'] as num).toDouble(),
      quantityOut: map['quantityOut'] == null
          ? 0.0
          : (map['quantityOut'] as num).toDouble(),
      initialQtCl: map['initialQtCl'] == null
          ? 0.0
          : (map['initialQtCl'] as num).toDouble(),
      finalQtCl:
          map['finalQtCl'] == null ? 0.0 : (map['finalQtCl'] as num).toDouble(),
    );
  }
}
