import 'package:models_weebi/src/closings/closing_ledger_herder.dart';
import 'package:models_weebi/src/extensions/closing_ledger_herders.dart';
import 'package:models_weebi/src/extensions/tickets_purchasing_power.dart';
import 'package:models_weebi/src/models/herder.dart';
import 'package:models_weebi/src/models/ticket_weebi.dart';

class HerderBalance {
  final int id;
  final num balance;
  const HerderBalance(this.id, this.balance);

  static const listOfHerderBalance = <HerderBalance>[
    HerderBalance(1, 10000),
    HerderBalance(2, 20000)
  ];
}

extension HerdersBalance on Iterable<Herder> {
  List<HerderBalance> makeListOfHerderBalance(Iterable<TicketWeebi> tickets,
      Iterable<ClosingLedgerHerder> closingsLedgerHerders,
      {DateTime? end}) {
    final listOfHerderBalance = <HerderBalance>[];
    toList().sort((a, b) => a.id.compareTo(b.id));
    for (final herder in this) {
      final endNotNull = end ?? DateTime.now();

      final lastClosingBalance =
          closingsLedgerHerders.closingHerderLastBalance(herder.id);

      final lent = 0;
      final ticketsPP =
          tickets.herderTicketsPurchasingPowerDateEnd(herder.id, endNotNull);

      final purchasingPower = ticketsPP + lastClosingBalance + lent;

      final bb = HerderBalance(herder.id, purchasingPower);
      listOfHerderBalance.add(bb);
    }
    return listOfHerderBalance;
  }
}
