import 'package:mobx/mobx.dart';
import 'package:models_weebi/base.dart';
import 'package:models_weebi/utils.dart';

class ArticleWMinQt extends ArticleAbstract {
  double minQt = 1.0;
  ArticleWMinQt(
    this.minQt, {
    required super.calibreId,
    required super.id,
    required super.fullName,
    required super.weight,
    super.articleCode,
    String? photo = '',
    required super.creationDate,
    DateTime? updateDate,
    DateTime? statusUpdateDate,
    @observable super.status = false,
  });

  @override
  bool operator ==(Object other) {
    if (identical(this, other)) return true;
    return other is ArticleWMinQt &&
        other.fullName == fullName &&
        other.id == id &&
        other.calibreId == calibreId &&
        other.creationDate == creationDate &&
        other.updateDate == updateDate;
  }

  static get dummy => ArticleWMinQt(
        1,
        calibreId: 1,
        id: 1,
        weight: 1,
        fullName: 'dummy',
        creationDate: WeebiDates.defaultDate,
        updateDate: WeebiDates.defaultDate,
        statusUpdateDate: WeebiDates.defaultDate,
      );

  @override
  int get hashCode => id.hashCode ^ fullName.hashCode;
}
