import 'package:models_weebi/base.dart' show ArticleAbstract;
import 'package:models_weebi/utils.dart' show DateRange;
import 'package:models_weebi/src/closings/abstract/stock_quantity.dart';

class ReportStockArticle extends ArticleAbstract
    implements DateRange, StockQuantityAbstract {
  @override
  double initialQtCl;
  @override
  double finalQtCl;
  @override
  DateTime start;
  @override
  DateTime end;
  double qtIn;
  double qtOut;
  ReportStockArticle({
    required int productId,
    required super.id,
    required this.start,
    required this.end,
    required this.initialQtCl,
    required this.finalQtCl,
    required this.qtIn,
    required this.qtOut,
    required super.fullName,
  }) : super(
          calibreId: productId,
          creationDate: DateTime.now(),
          status: true,
        );
}
