library report_stocks;

import 'package:models_weebi/src/closings/closing_stock_herder.dart';
import 'package:models_weebi/src/closings/closing_stock_shop/closing_stock_shop.dart';
import 'package:models_weebi/src/models/article_calibre.dart';
import 'package:models_weebi/src/models/herder.dart';
import 'package:models_weebi/src/models/shop_weebi.dart';
import 'package:models_weebi/src/models/ticket_weebi.dart';
import 'package:models_weebi/src/reports/compute_stock_mixin.dart';
import 'package:models_weebi/src/reports/report_abstracts.dart';
import 'package:models_weebi/src/models/utils/weebi_dates.dart';

class ReportStockHerder extends ReportStockAbstract<ClosingStockHerder>
    with ComputeStockHerder {
  final Herder herder;
  ReportStockHerder({
    required this.herder,
    required List<ClosingStockHerder> closingHerderStocks,
    required super.tickets,
    required super.articlesC,
    required super.startDate,
    required super.endDate,
  }) : super(
          objectId: '${herder.id}',
          closingsObjects: closingHerderStocks,
        );
}

class ReportStockShop extends ReportStockAbstract<ClosingStockShop>
    with ComputeStockShop {
  final ShopWeebi shop;
  ReportStockShop({
    required this.shop,
    required List<ClosingStockShop> closingStockShops,
    required super.tickets,
    required super.articlesC,
    required super.startDate,
    required super.endDate,
  }) : super(
          objectId: shop.uuid,
          closingsObjects: closingStockShops,
        );
  // ignore: missing_required_param
  static final dummy = ReportStockShop(
      shop: ShopWeebi.dummy,
      tickets: [TicketWeebi.dummySell],
      articlesC: [ArticleCalibre.dummyRetail],
      closingStockShops: [],
      startDate: WeebiDates.defaultFirstDate.add(const Duration(days: 1)),
      endDate: WeebiDates.defaultLastDate.subtract(const Duration(days: 1)));
}
